﻿-- Name		   : QuestLink
-- Version	   : v1.1
-- Create Date : 16-12-2016

local lastQuestSelected = GetQuestLogSelection();
local questSelected = lastQuestSelected;
local firstTime = true;

function QuestLink_OnEvent()
	local questSelected = GetQuestLogSelection();

	if WorldMapFrame:IsVisible() == true then 
		if QuestMapFrame.DetailsFrame:IsVisible() == true then
				if WQuestLinkButton:IsVisible() == true then
					WQuestLinkButton:Hide();
				end
				QuestLinkButton:Show();
				QuestLinkButton:SetFrameStrata("TOOLTIP");
				if (lastQuestSelected ~= questSelected or firstTime) then
					local questTitle, level, questTag, suggestedGroup, isHeader, isCollapsed, isComplete, questID = GetQuestLogTitle(questSelected)
					txtLink:SetText("http://wowhead.com/quest=" .. questID);
					lastQuestSelected = questSelected;
					txtLink:ClearFocus();
					firstTime = false;
				end	
		else 
				QuestLinkButton:Hide();
		end
	else
				QuestLinkFrame:Hide();
				QuestLinkButton:Hide();
	end 
end

function WQuestLinkButton_OnEvent()
	if WorldMapFrame:IsVisible() == true then 
		local mapID, isContinent = GetCurrentMapAreaID();
		if isContinent == false and mapID > -1 then
			if QuestMapFrame.DetailsFrame:IsVisible() == false then
				if IsWorldQuestWatched(GetSuperTrackedQuestID()) == false then
					if WQuestLinkButton:IsVisible() == true then
						WQuestLinkButton:Hide();
					end
				else
					if WQuestLinkButton:IsVisible() == false then
						WQuestLinkButton:SetFrameStrata("TOOLTIP");
						WQuestLinkButton:Show();
					end
				end
			end
		else
			if WQuestLinkButton:IsVisible() == true then
				WQuestLinkButton:Hide();
			end
		end
	end
end

function btnOpenWQLink_Click()
	if IsWorldQuestWatched(GetSuperTrackedQuestID()) == true then
		txtLink:SetText("http://wowhead.com/quest=" .. GetSuperTrackedQuestID());
		QuestLinkFrame:SetFrameStrata("TOOLTIP");
		txtLink:SetFont("Fonts\\FRIZQT__.TTF", 9);
		QuestLinkFrame:Show();
	end
end

function btnOpenLink_Click()
	QuestLinkFrame:SetFrameStrata("TOOLTIP");
	txtLink:SetFont("Fonts\\FRIZQT__.TTF", 9);
	QuestLinkFrame:Show();
end

function btnClose_Click()
	QuestLinkFrame:Hide();
end

function QuestLinkFrame_OnLoad()
	QuestLinkFrame:Hide();
	txtLink:SetAutoFocus(false);
	QuestLinkFrame:SetScript("OnEvent", QuestLink_OnEvent)
	QuestLinkFrame:RegisterForDrag("LeftButton");
end

function WQuestLinkButton_OnLoad()
	WQuestLinkButton:SetFrameStrata("TOOLTIP");
	WQuestLinkButton:Show();
	WQuestLinkButton:SetScript("OnEvent", WQuestLinkButton_OnEvent)
end